using System;
using System.Collections.Generic;
using System.Text;

namespace GGC_RefreshGrouping
{
    public class Adress : IValue, IComparable
    {
        private string m_Street;
        private string m_StreetNumber;
        private string m_City;

        public Adress()
        {
            m_Street = "<Street>";
            m_StreetNumber = "<StreetNumber>";
            m_City = "<City>";
        }
        
        public Adress(string street, string streetNumber, string city)
        {
            m_Street = street;
            m_StreetNumber = streetNumber;
            m_City = city;
        }
        
        public string Street
        {
            get { return m_Street; }
            set { m_Street = value; }
        }

        public string StreetNumber
        {
            get { return m_StreetNumber; }
            set { m_StreetNumber = value; }
        }

        public string City
        {
            get { return m_City; }
            set { m_City = value; }
        }
        
        public override string ToString()
        {
            return this.Street + "_" + this.StreetNumber + "," + this.City;
        }

        #region IValue Members

        public void Parse(string text)
        {
            int helpIndex1;
            int helpIndex2;

            //Parse the street
            helpIndex1 = text.IndexOf("_");
            this.Street = text.Substring(0, helpIndex1);

            //Parse the street number
            helpIndex2 = text.IndexOf(",", helpIndex1 + 1);
            this.StreetNumber = text.Substring(helpIndex1 + 1, helpIndex2 - helpIndex1 - 1);

            //Parse the city
            this.City = text.Substring(helpIndex2 + 1);            
        }

        #endregion

        #region IComparable Members

        public int CompareTo(object obj)
        {
            Adress adress = obj as Adress;

            return this.ToString().CompareTo(adress.ToString());
        }

        #endregion
    }
}
