using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC_RefreshGrouping
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitializeDisplayColumns();

            this.gridGroupingControl.DataSource = new PersonCollection();            
        }

        public void InitializeDisplayColumns()
        {
            ITypedList personCollection = new PersonCollection(); ;
            PropertyDescriptorCollection propCol = personCollection.GetItemProperties(null);

            if (gridGroupingControl.TableModel.CellModels.ContainsKey("CustomCell") == false)
                gridGroupingControl.TableModel.CellModels.Add("CustomCell", new CustomCellModel(gridGroupingControl.TableModel));

            foreach (PropertyDescriptor propDesc in propCol)
            {
                if (gridGroupingControl.TableDescriptor.Columns.Contains(propDesc.Name) == false)
                {
                    GridColumnDescriptor colDesc = new GridColumnDescriptor(propDesc.Name);
                    colDesc.MappingName = propDesc.Name;                    

                    if (propDesc.PropertyType.GetInterface(typeof(IValue).Name) != null)
                        colDesc.Appearance.AnyRecordFieldCell.CellType = "CustomCell";

                    gridGroupingControl.TableDescriptor.Columns.Add(colDesc);
                }
            }
        }
    }
}