using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace GGC_RefreshGrouping
{
    public class PersonCollection : BindingList<Person>, ITypedList
    {
        public PersonCollection()
        {                                    
            this.Add(new Person("Hans", "Mueller", new Adress("Salzstrasse", "5", "Frankfurt")));
            this.Add(new Person("Franz", "Beckenbauer", new Adress("Saebenerstrasse", "51", "Munich")));
            this.Add(new Person("Michael", "Schumacher", new Adress("Hockenheimring", "1", "Hockenheim")));
            this.Add(new Person("Ralf", "Schumacher", new Adress("Hockenheimring", "1", "Hockenheim")));

        }

        #region ITypedList Members

        public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors)
        {
            List<PropertyDescriptor> myList = new List<PropertyDescriptor>();

            PropertyDescriptorCollection myColl = TypeDescriptor.GetProperties(typeof(Person));
            foreach (PropertyDescriptor currDescr in myColl)
            {
                if (currDescr.IsBrowsable)
                    myList.Add(currDescr);
            }
                        
            PropertyDescriptorCollection pdc = new PropertyDescriptorCollection(myList.ToArray());
            return pdc;
        }

        public string GetListName(PropertyDescriptor[] listAccessors)
        {
            return "PersonCollection";
        }

        #endregion
    }
}
